#! /bin/bash
############################################################################
##                                                                        ##
##     Copyright (C) 2010-2011  YannUbuntu (yannubuntu@gmail.com)         ##
##                                                                        ##
## This program is free software: you can redistribute it and/or modify   ##
## it under the terms of the GNU General Public License as published by   ##
## the Free Software Foundation, either version 3 of the License, or      ##
## (at your option) any later version.                                    ##
##                                                                        ##
## This program is distributed in the hope that it will be useful,        ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of         ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          ##
## GNU General Public License for more details.                           ##
##                                                                        ##
## You should have received a copy of the GNU General Public License      ##
## along with this program.  If not, see <http://www.gnu.org/licenses/>.  ##
##                                                                        ##
############################################################################
## Special thanks to Babdu89 and GRUB devs.
## LIBRAIRIES FOR OS-UNINSTALLER AND BOOT REPAIR
## http://ubuntuforums.org/showthread.php?t=1615667

####################################### Main function for GUI preparation ####################
check_os_and_mount_blkid_partitions_gui() {
update_translations
echo "SET@_label0.set_text('''Os-prober. $(eval_gettext $'This may require several minutes...')''')"
delete_tmp_folder_to_be_cleared_and_update_osprober
echo "SET@_label0.set_text('''Mount. $(eval_gettext $'This may require several minutes...')''')"
check_if_live_session			#After update_translation and update_osprober, and before check_os_names
check_os_and_mount_blkid_partitions
echo "SET@_label0.set_text('''$(eval_gettext $'Scanning systems'). $(eval_gettext $'This may require several minutes...')''')"
determine_part_with_os			#Used by check_part_types and check_separate_boot_partitions
check_part_types				#After mount_all_blkid_partitions_except_df and determine_part_uuid
check_wubi_existence			#After mount_all_blkid_partitions_except_df
check_gpt
check_efi_dmesg
check_table_types
debug_echo_part_info
}

debug_echo_part_info() {
for ((i=1;i<=NBOFPARTITIONS;i++)); do
	echo "${LISTOFPARTITIONS[$i]} : ${DISK_PART[$i]}, ${PART_WITH_SEPARATEBOOT[$i]}, ${GRUBTYPE_OF_PART[$i]}, ${GRUBVER[$i]} , ${UPDATEGRUB_OF_PART[$i]}, ${APTTYP[$i]}, ${ARCH_OF_PART[$i]}, ${BOOTPRESENCE_OF_PART[$i]}, ${BLKIDMNT_POINT[$i]}, ${PART_WITH_OS[$i]}, ${GPTTYPE[$i]}, ${BIS_EFI_TYPE[$i]}, ${EFI_IN_FSTAB_OF_PART[$i]}."
done
hash parted && echo "
PARTED:

$(LANGUAGE=C LC_ALL=C parted -l)
"
echo "
MOUNT:
$MOUNTB

"
echo "SET@_label0.set_text('''$(eval_gettext $'Scanning systems'). $(eval_gettext $'Please wait few seconds...')''')"

#debug
a=/sys/block/;for x in $(ls $a);do if [[ ! "$x" =~ ram ]] && [[ ! "$x" =~ oop ]];then b="";for y in $(ls $a$x);do b="$b $y";done;echo "$a$x: $b";fi;done #debug
a="";for x in $(ls /dev);do if [[ ! "$x" =~ ram ]] && [[ ! "$x" =~ oop ]] && [[ ! "$x" =~ tty ]] && [[ ! "$x" =~ vcs ]];then a="$a $x";fi;done;echo "/dev: $a" #debug
for y in /dev/mapper /boot/efi; do if [ -d $y ];then a="";for x in $(ls $y);do a="$a $x";done;echo "$y: $a";fi;done #debug
}

####################################### DETERMINE PARTNB FROM A PARTNAME ################
determine_partnb() {
#Example of input : "sda1"
for ((partnbi=1;partnbi<=NBOFPARTITIONS;partnbi++)); do
	[[ "$1" = "${LISTOFPARTITIONS[$partnbi]}" ]] && PARTNB="$partnbi"
done
}

####################################### CHECK IF LIVE-SESSION ###############################
check_if_live_session() {
DISTRIB_DESCRIPTION="$(lsb_release -ds)"
if [ "$(grep -E '(boot=casper)|(boot=live)' /proc/cmdline)" ];then
	LIVESESSION="yes"
else 
	LIVESESSION="no"
	CURRENTSESSIONNAME="${The_system_now_in_use} - ${DISTRIB_DESCRIPTION}"
	DFROOT=$(df / | grep "/dev/" ); DFROOT=${DFROOT%% *}
	CURRENTSESSIONPARTITION="${DFROOT#*v/}"
	#Add CurrentSession at the beginning of OSPROBER (so that GRUB reinstall of CurrentSession is selected by default)
	echo "/dev/${CURRENTSESSIONPARTITION}:${CURRENTSESSIONNAME} CurrentSession:linux" >$TMP_FOLDER_TO_BE_CLEARED/osprober_with_currentsession
	echo "$OSPROBER" >> $TMP_FOLDER_TO_BE_CLEARED/osprober_with_currentsession
	OSPROBER=$(< $TMP_FOLDER_TO_BE_CLEARED/osprober_with_currentsession)
fi
echo "LIVESESSION is : $LIVESESSION ($DISTRIB_DESCRIPTION , $(lsb_release -cs) , $(lsb_release -is) , $(uname -m)  )"
}

####################################### CHECK IF WUBI ###############################
check_wubi_existence() {
TOTAL_QTY_OF_OS_INCLUDING_WUBI="$TOTAL_QUANTITY_OF_OS"; QTY_WUBI=0
for ((i=1;i<=NBOFPARTITIONS;i++)); do
	if [[ -f "${BLKIDMNT_POINT[$i]}/caixamagica/disks/root.disk" ]] ;then
		echo "There is Wubi inside ${LISTOFPARTITIONS[$i]}"
		(( TOTAL_QTY_OF_OS_INCLUDING_WUBI += 1 )); (( QTY_WUBI += 1 ))
		OS_NAME[$TOTAL_QTY_OF_OS_INCLUDING_WUBI]="$CaixaMagica_installed_in_Windows_via_Wubi"
		OS_PARTITION[$TOTAL_QTY_OF_OS_INCLUDING_WUBI]="${LISTOFPARTITIONS[$i]}"
		WUBI[$QTY_WUBI]="$TOTAL_QTY_OF_OS_INCLUDING_WUBI"
		WUBI_PART[$QTY_WUBI]="$i"
	fi
done
}

####################################### CHECK PART WITH OS ###############################
determine_part_with_os() {
#used by check_separate_boot_partitions & check_part_types
for ((i=1;i<=NBOFPARTITIONS;i++)); do
	PART_WITH_OS[$i]="no-os"
	for ((j=1;j<=TOTAL_QUANTITY_OF_OS;j++)); do
		if [[ "${LISTOFPARTITIONS[$i]}" = "${OS_PARTITION[$j]}" ]];then
			PART_WITH_OS[$i]="with-os"
			OSNAME[$i]="${OS_NAME[$j]}"
		fi
	done
	if [[ -d "${BLKIDMNT_POINT[$i]}/selinux" ]] && [[ "${PART_WITH_OS[$i]}" = "no-os" ]];then
		PART_WITH_OS[$i]="with-os"
		OSNAME[$i]="Linux not detected by os-prober"
	fi
	echo "[debug]PART_WITH_OS of ${LISTOFPARTITIONS[$i]} : ${PART_WITH_OS[$i]}"
done
for ((n=1;n<=NBOFDISKS;n++)); do
	for ((i=1;i<=NBOFPARTITIONS;i++)); do
		if [[ "${PART_WITH_OS[$i]}" = "with-os" ]] && [[ "${DISK_PART[$i]}" = "${LISTOFDISKS[$n]}" ]];then
			echo "[debug]${LISTOFDISKS[$n]} contains minimum one OS"
			DISK_WITHOS[$n]="with-os"
			break
		fi
	done
done
}

####################################### CHECK PART TYPES ##########################
check_part_types() {
QTY_OF_PART_WITH_GRUB=0
QTY_OF_PART_WITH_APTGET=0
QTY_OF_32BITS_PART=0
QTY_OF_64BITS_PART=0
QTY_BOOTPART=0
for ((i=1;i<=NBOFPARTITIONS;i++)); do
	GRUBTYPE_OF_PART[$i]=no-grub-install
	UPDATEGRUB_OF_PART[$i]=no-update-grub
	GRUBVER[$i]=grub	#will be last in purge list
	for gg in "/usr/sbin/" "/usr/bin/" "/sbin/" "/bin/";do #not sure "type" is available in all distros
		for gi in grub-install grub2-install grub-install.unsupported;do
			if [[ -f "${BLKIDMNT_POINT[$i]}${gg}${gi}" ]];then
				GRUBTYPE_OF_PART[$i]=${gi}
				GRUBVER[$i]=grub2
			fi
		done
		for gm in grub-mkconfig grub2-mkconfig;do
			[[ -f "${BLKIDMNT_POINT[$i]}${gg}${gm}" ]] && UPDATEGRUB_OF_PART[$i]="${gm} -o /boot/grub" #then complete with 2/grub.cfg or /grub.cfg
		done
	done
	for gg in "/usr/sbin/" "/usr/bin/" "/sbin/" "/bin/";do #Priority against grub-mkconfig
		[[ -f "${BLKIDMNT_POINT[$i]}${gg}update-grub" ]] && UPDATEGRUB_OF_PART[$i]=update-grub
	done
	if [[ "${GRUBTYPE_OF_PART[$i]}" = "grub-install" ]];then
		if [[ "${LISTOFPARTITIONS[$i]}" = "$CURRENTSESSIONPARTITION" ]];then
			[[ "$(grub-install -v )" =~ "0.9" ]] && GRUBVER[$i]=grub
		else
			for w in dev dev/pts proc sys; do mount -B /$w "${BLKIDMNT_POINT[$i]}/$w"; done
			[[ "$(chroot "${BLKIDMNT_POINT[$i]}" grub-install -v | grep "0.9")" ]] && GRUBVER[$i]=grub
			for w in dev/pts dev proc sys; do umount "${BLKIDMNT_POINT[$i]}/$w"; done
		fi
	fi
	if [[ "${GRUBTYPE_OF_PART[$i]}" = "grub-install" ]] || [[ "${GRUBTYPE_OF_PART[$i]}" = "grub2-install" ]];then
		(( QTY_OF_PART_WITH_GRUB += 1 ))
		LIST_OF_PART_WITH_GRUB[$QTY_OF_PART_WITH_GRUB]="$i"
	fi
	
	if [[ -f "${BLKIDMNT_POINT[$i]}/usr/bin/apt-get" ]] || [[ -f "${BLKIDMNT_POINT[$i]}/usr/bin/yum" ]] || [[ -f "${BLKIDMNT_POINT[$i]}/usr/bin/zypper" ]] || [[ -f "${BLKIDMNT_POINT[$i]}/usr/bin/pacman" ]];then
		(( QTY_OF_PART_WITH_APTGET += 1 ));
		LIST_OF_PART_WITH_APTGET[$QTY_OF_PART_WITH_APTGET]="$i"
		if [[ -f "${BLKIDMNT_POINT[$i]}/usr/bin/apt-get" ]];then
			APTTYP[$i]=apt-get
			YESTYP[$i]="-y --force-yes"
			INSTALLTYP[$i]=install
			PURGETYP[$i]=purge
			POLICYTYP[$i]="apt-cache policy"
			CANDIDATETYP[$i]="grep Candidate"
			CANDIDATETYP2[$i]="grep -v none"
			UPDATETYP[$i]="-y --force-yes update"
		elif [[ -f "${BLKIDMNT_POINT[$i]}/usr/bin/yum" ]];then
			APTTYP[$i]=yum
			YESTYP[$i]=-y
			INSTALLTYP[$i]=install
			PURGETYP[$i]=erase
			POLICYTYP[$i]="yum info name"
			CANDIDATETYP[$i]="grep Available"
			UPDATETYP[$i]=makecache
		elif [[ -f "${BLKIDMNT_POINT[$i]}/usr/bin/zypper" ]];then
			APTTYP[$i]=zypper
			YESTYP[$i]=-y
			INSTALLTYP[$i]=install
			PURGETYP[$i]=remove
			POLICYTYP[$i]="zypper info"
			CANDIDATETYP[$i]="grep Installed"
			UPDATETYP[$i]=refresh
		elif [[ -f "${BLKIDMNT_POINT[$i]}/usr/bin/pacman" ]];then
			APTTYP[$i]=pacman
			YESTYP[$i]=--noconfirm
			INSTALLTYP[$i]=-Sy
			PURGETYP[$i]=-R
			POLICYTYP[$i]="pacman -Syw --noconfirm"
			CANDIDATETYP[$i]="grep download"
			UPDATETYP[$i]="-Sy --noconfirm pacman"
			UPDATETYP2[$i]="pacman-db-upgrade"
		fi
	else
		APTTYP[$i]=no-apt-nor-yum
	fi
	if [[ "${CURRENTSESSIONPARTITION}" = "${LISTOFPARTITIONS[$i]}" ]] && [[ "$(uname -m)" = "i686" ]] \
	|| [[ ! -d "${BLKIDMNT_POINT[$i]}/lib64" ]] || [[ "$(cat /proc/cpuinfo | grep flags | head -n1 | grep lm | wc -l)" = "0" ]];then
		ARCH_OF_PART[$i]="32"
		(( QTY_OF_32BITS_PART += 1 ))
	else
		ARCH_OF_PART[$i]="64"
		(( QTY_OF_64BITS_PART += 1 ))
	fi
	if [[ ! -d "${BLKIDMNT_POINT[$i]}/boot/grub" ]] && [[ ! -d "${BLKIDMNT_POINT[$i]}/boot/grub2" ]];then
		BOOTPRESENCE_OF_PART[$i]="no boot" # REINSTALL_POSSIBLE will be Yes only if a separate boot exists
	elif [[ ! "$(ls "${BLKIDMNT_POINT[$i]}/boot/grub" )" ]] && [[ ! "$(ls "${BLKIDMNT_POINT[$i]}/boot/grub2" )" ]];then
		BOOTPRESENCE_OF_PART[$i]="no boot"
	else # REINSTALL_POSSIBLE will be Yes
		BOOTPRESENCE_OF_PART[$i]="with boot"
		if [[ -f "${BLKIDMNT_POINT[$i]}/etc/fstab" ]];then
			[[ "$(cat "${BLKIDMNT_POINT[$i]}/etc/fstab" | grep "/boot" | grep -v "/boot/" )" ]] && BOOTPRESENCE_OF_PART[$i]="maybe separate"
		fi
	fi
	if [[ -f "${BLKIDMNT_POINT[$i]}/etc/fstab" ]];then
		if [[ "$(cat "${BLKIDMNT_POINT[$i]}/etc/fstab" )" =~ "/boot/efi" ]];then
			EFI_IN_FSTAB_OF_PART[$i]="fstab-efi"
			a="$(cat "${BLKIDMNT_POINT[$i]}/etc/fstab" | grep "/boot/efi" )"; b="${a%% *}"
			if [[ "$b" =~ UUID ]];then # e.g. UUID=0EC9-AA63  /boot/efi       vfat    defaults        0       1
				UUID_OF_EFIPART="${b##*=}"
				for ((uuidp=1;uuidp<=NBOFPARTITIONS;uuidp++)); do
					[[ "${PART_UUID[$uuidp]}" = "$UUID_OF_EFIPART" ]] && EFI_OF_PART[$i]="$uuidp"
				done
			elif [[ "$b" =~ "/dev/" ]];then
				PARTOF_EFIPART="${b##*dev/}"
				EFI_OF_PART[$i]="$(determine_partnb $uuidp )"	
			fi
			echo "EFI_OF_PART[$i] ${EFI_OF_PART[$i]} ($UUID_OF_EFIPART, $PARTOF_EFIPART)"
		else
			EFI_IN_FSTAB_OF_PART[$i]=fstab-without-efi
		fi
	else
		EFI_IN_FSTAB_OF_PART[$i]=no-fstab
	fi
	PART_WITH_SEPARATEBOOT[$i]=not-sepboot
	if [[ "${PART_WITH_OS[$i]}" = "no-os" ]];then
		PART_WITH_SEPARATEBOOT[$i]=is-maybe-sepboot
		if [[ -d "${BLKIDMNT_POINT[$i]}/grub" ]] || [[ -d "${BLKIDMNT_POINT[$i]}/grub2" ]];then
			echo "${LISTOFPARTITIONS[$i]} contains a /grub or /grub2 folder, so it is probably a /boot partition."
			(( QTY_BOOTPART += 1 ))
			PART_WITH_SEPARATEBOOT[$i]=is-sepboot
		fi
	fi
done
}

####################################### CHECK GPT ################################"
check_gpt() {
FDISKL="$(LANGUAGE=C LC_ALL=C sudo fdisk -lu)"
QTY_GPTPART=0
for ((i=1;i<=NBOFPARTITIONS;i++)); do
	GPTTYPE[$i]=no-gpt
done
while read line; do
	echo "[debug]Line $line"
	if [[ "$(grep -i "GPT" <<< $line )" ]];then
		temp=${line%% *}; part=${temp#*dev/}
		(( QTY_GPTPART += 1 ))
		determine_partnb $part
		LIST_GPTPART[$QTY_GPTPART]="$PARTNB"
		GPTTYPE[$PARTNB]=gpt
		echo "LIST_GPTPART[$QTY_GPTPART] is $PARTNB ($part , $disk)"
	fi
done < <(echo "$FDISKL")
}

####################################### CHECK EFI SESSION ##################
check_efi_dmesg() {
if [[ "$(dmesg | grep EFI | grep -v "Variables Facility" )" ]];then
	EFIDMESG=EFIsession
	echo "$EFIDMSG: $(dmesg | grep EFI)"
else
	EFIDMESG=notEFIsession
fi
}

####################################### CHECK EFI PARTITIONS (cf BIS) #####################

check_table_types() {
local disk partnb
NB_BISEFIPART=0
for ((partnb=1;partnb<=NBOFPARTITIONS;partnb++));do
	BIS_EFI_TYPE[$partnb]=notEFItable #init
done
for ((disk=1;disk<=NBOFDISKS;disk++)); do
	# Look at the first 4 bytes of the second sector to identify the partition table type.
	case $(hexdump -v -s 512 -n 4 -e '"%_u"' /dev/${LISTOFDISKS[$disk]}) in
		'EMBR') TABLE_TYPE[$disk]='BootIt';;
		'EFI ') TABLE_TYPE[$disk]='EFI'; ReadEFI /dev/${LISTOFDISKS[$disk]};;
			 *) TABLE_TYPE[$disk]='MSDos'; MSDOSPRESENT=yes;;
	esac
	echo "TABLE_TYPE of ${LISTOFDISKS[$disk]} is ${TABLE_TYPE[$disk]}"	
done
}

ReadEFI() {
local drive=$1 N=0 i=0 part partnb PRStart PRSize
PRStart=$(Read8Bytes 584 ${drive})
N=$(Read4Bytes 592 ${drive})
PRStart=$((${PRStart}*512))
PRSize=$(Read4Bytes 596 ${drive})
echo "ReadEFI: $drive , N $N , $i , $part , PRStart $PRStart , PRSize $PRSize"
for (( i = 0; i < N; i++ )) ; do
	part=${drive}$((${i}+1))	#may not work for LVM
	for ((partnb=1;partnb<=NBOFPARTITIONS;partnb++));do
		if [[ "/dev/${LISTOFPARTITIONS[$partnb]}" = "$part" ]];then
			if [[ "$(hexdump -v -s $((${PRStart}+${PRSize}*${i})) -n 16 -e '/1 "%02x"' ${drive})" = '28732ac11ff8d211ba4b00a0c93ec93b' ]]; then
				BIS_EFI_TYPE[$partnb]=BISEFI
				(( NB_BISEFIPART += 1 ))
				BISEFIPART[$NB_BISEFIPART]="$partnb"
			else
				BIS_EFI_TYPE[$partnb]=notBISEFI
			fi
			echo "part $part is ${BIS_EFI_TYPE[$partnb]}"
		fi
	done
done
}

## Read 4 bytes starting at $1 of device $2 and convert result to decimal
Read4Bytes() {
local start=$1 device=$2
echo $(hexdump -v -s ${start} -n 4 -e '4 "%u"' ${device})
}

## Read 8 bytes starting at $1 of device $2 and convert result to decimal
Read8Bytes() {
local start=$1 device=$2
local first4 second4
# Get ${first4} and ${second4} bytes at once.
eval $(hexdump -v -s ${start} -n 8 -e '1/4 "first4=%u; " 1/4 "second4=%u"' ${device})
echo $(( ${second4} * 1073741824 + ${first4} ))
}

####################################### WARNINGS BEFORE DISPLAYING MAIN MENU ################
check_options_warning() {
if [[ "$NB_BISEFIPART" != "0" ]] && [[ "$EFIDMESG" = "EFIsession" ]];then
	FUNCTION=EFI
	update_translations
	zenity --info --title="$(eval_gettext "$CLEANNAME")" --text="${FUNCTION_detected} ${Please_check_options}"
fi
if [[ "$QTY_BOOTPART" != "0" ]];then
	FUNCTION="/boot"
	update_translations
	zenity --info --title="$(eval_gettext "$CLEANNAME")" --text="${FUNCTION_detected} ${Please_check_options}"
fi
}

warnings_and_show_mainwindow() {
echo "
************************Before mainwindow"; debug_echo_important_variables
end_of_pulsate
check_options_warning
echo 'SET@_mainwindow.show()'
}

debug_echo_important_variables() {
if [[ "$APPNAME" = "boot-repair" ]];then
	echo "FSCK_ACTION $FSCK_ACTION PASTEBIN_ACTION $PASTEBIN_ACTION "
else
	echo "FORMAT_OS $FORMAT_OS ($FORMAT_TYPE) WUBI_TO_DELETE $WUBI_TO_DELETE ADVISE_BOOTLOADER_UPDATE $ADVISE_BOOTLOADER_UPDATE"
fi
echo "$MAIN_MENU, $MBR_ACTION, REINSTALL_POSSIBLE $REINSTALL_POSSIBLE PURGE_POSSIBLE $PURGE_POSSIBLE
UNHIDEBOOT_ACTION $UNHIDEBOOT_ACTION (${UNHIDEBOOT_TIME}s), $BOOTFLAG_ACTION (${LISTOFPARTITIONS[$BOOTFLAG_TO_USE]})
PART_TO_REINSTALL_GRUB ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB]}, PART_TO_REINSTALL_GRUB_PURGE ${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB_PURGE]}, FORCE_GRUB $FORCE_GRUB ($NOFORCE_DISK) REMOVABLEDISK $REMOVABLEDISK 
USE_SEPARATEBOOTPART $USE_SEPARATEBOOTPART (${LISTOFPARTITIONS[$BOOTPART_TO_USE]}) $GRUBPACKAGE (${LISTOFPARTITIONS[$EFIPART_TO_USE]})
UNCOMMENT_GFXMODE $UNCOMMENT_GFXMODE ATA $ATA ADD_KERNEL_OPTION $ADD_KERNEL_OPTION ($CHOSEN_KERNEL_OPTION)
MBR_TO_RESTORE $MBR_TO_RESTORE ($DISK_TO_RESTORE_MBR $TARGET_PARTITION_FOR_MBR)"
}

